"use strict";
var _EditorImpl_markup, _EditorImpl_editorMode, _EditorImpl_toolbarVisible, _EditorImpl_splitModeEnabled, _EditorImpl_splitMode, _EditorImpl_renderPreview, _EditorImpl_wysiwygEditor, _EditorImpl_markupEditor, _EditorImpl_markupConfig, _EditorImpl_escapeConfig, _EditorImpl_preset, _EditorImpl_allowHTML, _EditorImpl_linkify, _EditorImpl_linkifyTlds, _EditorImpl_extensions, _EditorImpl_renderStorage, _EditorImpl_fileUploadHandler, _EditorImpl_needToSetDimensionsForUploadedImages, _EditorImpl_prepareRawMarkup, _EditorImpl_beforeEditorModeChange;
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorImpl = void 0;
const tslib_1 = require("tslib");
const view_1 = require("@codemirror/view");
const prosemirror_state_1 = require("prosemirror-state");
const core_1 = require("../core");
const bundle_1 = require("../i18n/bundle");
const logger_1 = require("../logger");
const codemirror_1 = require("../markup/codemirror");
const editor_1 = require("../markup/editor");
const event_emitter_1 = require("../utils/event-emitter");
/** @internal */
class EditorImpl extends event_emitter_1.SafeEventEmitter {
    constructor(opts) {
        var _a, _b, _c, _d, _e, _f;
        var _g;
        super({ onError: logger_1.logger.error.bind(logger_1.logger) });
        _EditorImpl_markup.set(this, void 0);
        _EditorImpl_editorMode.set(this, void 0);
        _EditorImpl_toolbarVisible.set(this, void 0);
        _EditorImpl_splitModeEnabled.set(this, void 0);
        _EditorImpl_splitMode.set(this, void 0);
        _EditorImpl_renderPreview.set(this, void 0);
        _EditorImpl_wysiwygEditor.set(this, void 0);
        _EditorImpl_markupEditor.set(this, void 0);
        _EditorImpl_markupConfig.set(this, void 0);
        _EditorImpl_escapeConfig.set(this, void 0);
        _EditorImpl_preset.set(this, void 0);
        _EditorImpl_allowHTML.set(this, void 0);
        _EditorImpl_linkify.set(this, void 0);
        _EditorImpl_linkifyTlds.set(this, void 0);
        _EditorImpl_extensions.set(this, void 0);
        _EditorImpl_renderStorage.set(this, void 0);
        _EditorImpl_fileUploadHandler.set(this, void 0);
        _EditorImpl_needToSetDimensionsForUploadedImages.set(this, void 0);
        _EditorImpl_prepareRawMarkup.set(this, void 0);
        _EditorImpl_beforeEditorModeChange.set(this, void 0);
        this.getValue = () => this.currentEditor.getValue();
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_editorMode, (_a = opts.initialEditorMode) !== null && _a !== void 0 ? _a : 'wysiwyg', "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_toolbarVisible, Boolean(opts.initialToolbarVisible), "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_splitMode, (_b = (opts.renderPreview && opts.splitMode)) !== null && _b !== void 0 ? _b : false, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_splitModeEnabled, (_c = (tslib_1.__classPrivateFieldGet(this, _EditorImpl_splitMode, "f") && opts.initialSplitModeEnabled)) !== null && _c !== void 0 ? _c : false, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_renderPreview, opts.renderPreview, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_markup, (_d = opts.initialMarkup) !== null && _d !== void 0 ? _d : '', "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_preset, (_e = opts.preset) !== null && _e !== void 0 ? _e : 'full', "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_linkify, opts.linkify, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_linkifyTlds, opts.linkifyTlds, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_allowHTML, opts.allowHTML, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_extensions, opts.extensions, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_markupConfig, Object.assign({}, opts.markupConfig), "f");
        (_f = (_g = tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f")).extensions) !== null && _f !== void 0 ? _f : (_g.extensions = opts.extraMarkupExtensions);
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_renderStorage, opts.renderStorage, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_fileUploadHandler, opts.fileUploadHandler, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_needToSetDimensionsForUploadedImages, Boolean(opts.needToSetDimensionsForUploadedImages), "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_prepareRawMarkup, opts.prepareRawMarkup, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_escapeConfig, opts.escapeConfig, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_beforeEditorModeChange, opts.experimental_beforeEditorModeChange, "f");
    }
    get _wysiwygView() {
        var _a;
        // @ts-expect-error internal typing
        return (_a = tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f")) === null || _a === void 0 ? void 0 : _a.view;
    }
    get currentMode() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_editorMode, "f");
    }
    set currentMode(newMode) {
        var _a, _b, _c;
        switch (newMode) {
            case 'markup': {
                tslib_1.__classPrivateFieldSet(this, _EditorImpl_editorMode, newMode, "f");
                if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f")) {
                    const markupEditorValue = (_a = tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f")) === null || _a === void 0 ? void 0 : _a.getValue();
                    const wysiwygEditorValue = tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f").getValue();
                    if (!markupEditorValue ||
                        this.shouldReplaceMarkupEditorValue(markupEditorValue, wysiwygEditorValue)) {
                        tslib_1.__classPrivateFieldSet(this, _EditorImpl_markup, wysiwygEditorValue, "f");
                    }
                    else {
                        tslib_1.__classPrivateFieldSet(this, _EditorImpl_markup, markupEditorValue, "f");
                    }
                }
                if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f"))
                    tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f").replace(tslib_1.__classPrivateFieldGet(this, _EditorImpl_markup, "f"));
                break;
            }
            case 'wysiwyg': {
                tslib_1.__classPrivateFieldSet(this, _EditorImpl_editorMode, newMode, "f");
                if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f")) {
                    const value = tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f").getValue();
                    tslib_1.__classPrivateFieldSet(this, _EditorImpl_markup, (_c = (_b = tslib_1.__classPrivateFieldGet(this, _EditorImpl_prepareRawMarkup, "f")) === null || _b === void 0 ? void 0 : _b.call(this, value)) !== null && _c !== void 0 ? _c : value, "f");
                }
                else if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_prepareRawMarkup, "f")) {
                    tslib_1.__classPrivateFieldSet(this, _EditorImpl_markup, tslib_1.__classPrivateFieldGet(this, _EditorImpl_prepareRawMarkup, "f").call(this, tslib_1.__classPrivateFieldGet(this, _EditorImpl_markup, "f")), "f");
                }
                if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f"))
                    tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f").replace(tslib_1.__classPrivateFieldGet(this, _EditorImpl_markup, "f"));
                break;
            }
            default:
                throw new Error('Unknown editor mode: ' + newMode);
        }
        setTimeout(() => {
            this.currentEditor.focus();
        }, 30);
    }
    get toolbarVisible() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_toolbarVisible, "f");
    }
    get splitModeEnabled() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_splitModeEnabled, "f");
    }
    get splitMode() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_splitMode, "f");
    }
    get preset() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_preset, "f");
    }
    get renderPreview() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_renderPreview, "f");
    }
    get currentEditor() {
        const mode = this.currentMode;
        switch (mode) {
            case 'markup':
                return this.markupEditor;
            case 'wysiwyg':
                return this.wysiwygEditor;
            default:
                throw new Error('Unknown editor mode: ' + mode);
        }
    }
    get wysiwygEditor() {
        if (!tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f")) {
            const mdPreset = tslib_1.__classPrivateFieldGet(this, _EditorImpl_preset, "f") === 'zero' || tslib_1.__classPrivateFieldGet(this, _EditorImpl_preset, "f") === 'commonmark' ? tslib_1.__classPrivateFieldGet(this, _EditorImpl_preset, "f") : 'default';
            tslib_1.__classPrivateFieldSet(this, _EditorImpl_wysiwygEditor, new core_1.WysiwygEditor({
                mdPreset,
                initialContent: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markup, "f"),
                extensions: tslib_1.__classPrivateFieldGet(this, _EditorImpl_extensions, "f"),
                allowHTML: tslib_1.__classPrivateFieldGet(this, _EditorImpl_allowHTML, "f"),
                linkify: tslib_1.__classPrivateFieldGet(this, _EditorImpl_linkify, "f"),
                linkifyTlds: tslib_1.__classPrivateFieldGet(this, _EditorImpl_linkifyTlds, "f"),
                escapeConfig: tslib_1.__classPrivateFieldGet(this, _EditorImpl_escapeConfig, "f"),
                onChange: () => this.emit('rerender-toolbar', null),
                onDocChange: () => this.emit('change', null),
            }), "f");
        }
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f");
    }
    get markupEditor() {
        var _a;
        if (!tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f")) {
            tslib_1.__classPrivateFieldSet(this, _EditorImpl_markupEditor, new editor_1.Editor((0, codemirror_1.createCodemirror)({
                doc: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markup, "f"),
                placeholder: (_a = tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f").placeholder) !== null && _a !== void 0 ? _a : (0, bundle_1.i18n)('markup_placeholder'),
                onCancel: () => this.emit('cancel', null),
                onSubmit: () => this.emit('submit', null),
                onChange: () => this.emit('rerender-toolbar', null),
                onDocChange: () => this.emit('change', null),
                onScroll: (event) => this.emit('cm-scroll', { event }),
                reactRenderer: tslib_1.__classPrivateFieldGet(this, _EditorImpl_renderStorage, "f"),
                uploadHandler: this.fileUploadHandler,
                needImgDimms: this.needToSetDimensionsForUploadedImages,
                extensions: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f").extensions,
                disabledExtensions: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f").disabledExtensions,
                keymaps: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f").keymaps,
                yfmLangOptions: { languageData: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f").languageData },
                autocompletion: tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupConfig, "f").autocompletion,
                receiver: this,
            })), "f");
        }
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f");
    }
    get renderStorage() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_renderStorage, "f");
    }
    get fileUploadHandler() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_fileUploadHandler, "f");
    }
    get needToSetDimensionsForUploadedImages() {
        return tslib_1.__classPrivateFieldGet(this, _EditorImpl_needToSetDimensionsForUploadedImages, "f");
    }
    // ---> implements CodeEditor
    get cm() {
        return this.markupEditor.cm;
    }
    // <--- implements CodeEditor
    // ---> implements ActionStorage
    get actions() {
        return this.wysiwygEditor.actions;
    }
    action(actionName) {
        return this.wysiwygEditor.action(actionName);
    }
    // <--- implements ActionStorage
    destroy() {
        var _a, _b;
        (_a = tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f")) === null || _a === void 0 ? void 0 : _a.destroy();
        (_b = tslib_1.__classPrivateFieldGet(this, _EditorImpl_markupEditor, "f")) === null || _b === void 0 ? void 0 : _b.codemirror.destroy();
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_markupEditor, undefined, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_markupEditor, undefined, "f");
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_wysiwygEditor, undefined, "f");
    }
    setEditorMode(mode, opts) {
        this.changeEditorMode({ mode, reason: 'manually', emit: opts === null || opts === void 0 ? void 0 : opts.emit });
    }
    changeEditorMode(_a) {
        var _b;
        var { emit = true } = _a, opts = tslib_1.__rest(_a, ["emit"]);
        if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_editorMode, "f") === opts.mode)
            return;
        if (((_b = tslib_1.__classPrivateFieldGet(this, _EditorImpl_beforeEditorModeChange, "f")) === null || _b === void 0 ? void 0 : _b.call(this, { mode: opts.mode, reason: opts.reason })) === false) {
            return;
        }
        this.currentMode = opts.mode;
        this.emit('rerender', null);
        if (emit) {
            this.emit('change-editor-mode', opts);
        }
    }
    changeToolbarVisibility(opts) {
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_toolbarVisible, opts.visible, "f");
        this.emit('rerender', null);
        this.emit('change-toolbar-visibility', opts);
    }
    changeSplitModeEnabled(opts) {
        if (tslib_1.__classPrivateFieldGet(this, _EditorImpl_splitModeEnabled, "f") === opts.splitModeEnabled)
            return;
        tslib_1.__classPrivateFieldSet(this, _EditorImpl_splitModeEnabled, opts.splitModeEnabled, "f");
        this.emit('rerender', null);
        this.emit('change-split-mode-enabled', opts);
    }
    focus() {
        return this.currentEditor.focus();
    }
    hasFocus() {
        return this.currentEditor.hasFocus();
    }
    isEmpty() {
        return this.currentEditor.isEmpty();
    }
    clear() {
        return this.currentEditor.clear();
    }
    replace(newMarkup) {
        return this.currentEditor.replace(newMarkup);
    }
    prepend(markup) {
        return this.currentEditor.prepend(markup);
    }
    append(markup) {
        return this.currentEditor.append(markup);
    }
    moveCursor(position) {
        if (typeof position === 'object') {
            return this.moveCursorToLine(position.line);
        }
        return this.currentEditor.moveCursor(position);
    }
    moveCursorToLine(/** 0-based line number */ line) {
        const mode = this.currentMode;
        switch (mode) {
            case 'markup': {
                const view = this.markupEditor.cm;
                let cmLine = line + 1; // lines in codemirror is 1-based
                cmLine = Math.max(cmLine, 1);
                cmLine = Math.min(cmLine, view.state.doc.lines);
                const yMargin = getTopOffset();
                const anchor = view.state.doc.line(cmLine).from;
                view.dispatch({
                    scrollIntoView: true,
                    selection: { anchor },
                    effects: [
                        view_1.EditorView.scrollIntoView(anchor, { y: 'start', x: 'start', yMargin }),
                    ],
                });
                break;
                // eslint-disable-next-line no-inner-declarations
                function getTopOffset() {
                    const TOOLBAR_HEIGHT = 36; //px
                    const TOOLBAR_BOTTOM_OFFSET = 8; // px
                    const TOOLBAR_TOP_ADDITIONAL_OFFSET = 8; // px
                    const TOOLBAR_TOP_OFFSET_VAR = '--g-md-toolbar-sticky-offset';
                    const topOffsetValue = window
                        .getComputedStyle(view.dom)
                        .getPropertyValue(TOOLBAR_TOP_OFFSET_VAR);
                    const toolbarTopOffset = calculateCSSNumberValue(topOffsetValue) + TOOLBAR_TOP_ADDITIONAL_OFFSET;
                    return toolbarTopOffset + TOOLBAR_HEIGHT + TOOLBAR_BOTTOM_OFFSET;
                }
            }
            case 'wysiwyg': {
                const node = this.wysiwygEditor.dom.querySelector(`[data-line="${line}"]`);
                if (node) {
                    const position = this._wysiwygView.posAtDOM(node, 0);
                    const { tr } = this._wysiwygView.state;
                    this._wysiwygView.dispatch(tr.setSelection(prosemirror_state_1.TextSelection.create(tr.doc, position)).scrollIntoView());
                }
                break;
            }
            default:
                throw new Error('Unknown editor mode: ' + mode);
        }
    }
    shouldReplaceMarkupEditorValue(markupValue, wysiwygValue) {
        var _a;
        const serializedEditorMarkup = (_a = tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f")) === null || _a === void 0 ? void 0 : _a.serializer.serialize(tslib_1.__classPrivateFieldGet(this, _EditorImpl_wysiwygEditor, "f").parser.parse(markupValue), tslib_1.__classPrivateFieldGet(this, _EditorImpl_escapeConfig, "f"));
        return (serializedEditorMarkup === null || serializedEditorMarkup === void 0 ? void 0 : serializedEditorMarkup.trim()) !== wysiwygValue.trim();
    }
}
exports.EditorImpl = EditorImpl;
_EditorImpl_markup = new WeakMap(), _EditorImpl_editorMode = new WeakMap(), _EditorImpl_toolbarVisible = new WeakMap(), _EditorImpl_splitModeEnabled = new WeakMap(), _EditorImpl_splitMode = new WeakMap(), _EditorImpl_renderPreview = new WeakMap(), _EditorImpl_wysiwygEditor = new WeakMap(), _EditorImpl_markupEditor = new WeakMap(), _EditorImpl_markupConfig = new WeakMap(), _EditorImpl_escapeConfig = new WeakMap(), _EditorImpl_preset = new WeakMap(), _EditorImpl_allowHTML = new WeakMap(), _EditorImpl_linkify = new WeakMap(), _EditorImpl_linkifyTlds = new WeakMap(), _EditorImpl_extensions = new WeakMap(), _EditorImpl_renderStorage = new WeakMap(), _EditorImpl_fileUploadHandler = new WeakMap(), _EditorImpl_needToSetDimensionsForUploadedImages = new WeakMap(), _EditorImpl_prepareRawMarkup = new WeakMap(), _EditorImpl_beforeEditorModeChange = new WeakMap();
function calculateCSSNumberValue(cssValue) {
    const tmp = document.createElement('div');
    tmp.style.position = 'absolute';
    tmp.style.top = '-99999px';
    tmp.style.left = '-99999px';
    tmp.style.width = `calc(${cssValue})`;
    document.body.appendChild(tmp);
    const value = tmp.getBoundingClientRect().width;
    tmp.remove();
    return value;
}
