"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkupEditorView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const classname_1 = require("../classname");
const extensions_1 = require("../extensions");
const logger_1 = require("../logger");
const hooks_1 = require("../react-utils/hooks");
const MarkupEditorComponent_1 = require("./MarkupEditorComponent");
const ToolbarView_1 = require("./ToolbarView");
const context_1 = require("./toolbar/markup/context");
const b = (0, classname_1.cn)('markup-editor');
exports.MarkupEditorView = react_1.default.memo((props) => {
    const { editor, autofocus, settingsVisible, toolbarVisible, toolbarConfig, hiddenActionsConfig, className, toolbarClassName, children, stickyToolbar = true, } = props;
    (0, hooks_1.useRenderTime)((time) => {
        logger_1.logger.metrics({
            component: 'markup-editor',
            event: 'render',
            duration: time,
        });
    });
    return (react_1.default.createElement("div", { className: b({ toolbar: toolbarVisible }, [className]) },
        toolbarVisible ? (react_1.default.createElement(context_1.MarkupToolbarContextProvider, { value: {
                uploadHandler: editor.fileUploadHandler,
                needToSetDimensionsForUploadedImages: editor.needToSetDimensionsForUploadedImages,
            } },
            react_1.default.createElement(ToolbarView_1.ToolbarView, { editor: editor, editorMode: "markup", toolbarEditor: editor, hiddenActionsConfig: hiddenActionsConfig, stickyToolbar: stickyToolbar, toolbarConfig: toolbarConfig, toolbarFocus: () => editor.focus(), settingsVisible: settingsVisible, className: b('toolbar', [toolbarClassName]) }, children))) : null,
        react_1.default.createElement(MarkupEditorComponent_1.MarkupEditorComponent, { autofocus: autofocus, editor: editor, className: b('editor', { 'toolbar-visible': toolbarVisible }) },
            react_1.default.createElement(extensions_1.ReactRendererComponent, { storage: editor.renderStorage }))));
});
exports.MarkupEditorView.displayName = 'MarkdownMarkupEditorView';
