"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WysiwygEditorComponent = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const WysiwygEditorComponent = function WysiwygEditorComponent({ className, autofocus, editor, children }) {
    const ref = react_1.default.useRef(null);
    react_1.default.useEffect(() => {
        const { current } = ref;
        if (current) {
            current.appendChild(editor.wysiwygEditor.dom);
            if (autofocus) {
                editor.focus();
            }
        }
    }, [editor]);
    return (react_1.default.createElement("div", { ref: ref, className: className }, children));
};
exports.WysiwygEditorComponent = WysiwygEditorComponent;
