"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WysiwygEditorView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const classname_1 = require("../classname");
const extensions_1 = require("../extensions");
const logger_1 = require("../logger");
const hooks_1 = require("../react-utils/hooks");
const ToolbarView_1 = require("./ToolbarView");
const WysiwygEditorComponent_1 = require("./WysiwygEditorComponent");
const b = (0, classname_1.cn)('wysiwyg-editor');
exports.WysiwygEditorView = react_1.default.memo((props) => {
    const { editor, autofocus, settingsVisible, toolbarVisible, toolbarConfig, hiddenActionsConfig, className, toolbarClassName, children, stickyToolbar = true, } = props;
    (0, hooks_1.useRenderTime)((time) => {
        logger_1.logger.metrics({
            component: 'wysiwyg-editor',
            event: 'render',
            duration: time,
        });
    });
    return (react_1.default.createElement("div", { className: b({ toolbar: toolbarVisible }, [className]) },
        toolbarVisible ? (react_1.default.createElement(ToolbarView_1.ToolbarView, { editor: editor, editorMode: "wysiwyg", toolbarEditor: editor, stickyToolbar: stickyToolbar, toolbarConfig: toolbarConfig, toolbarFocus: () => editor.focus(), hiddenActionsConfig: hiddenActionsConfig, settingsVisible: settingsVisible, className: b('toolbar', [toolbarClassName]) }, children)) : null,
        react_1.default.createElement(WysiwygEditorComponent_1.WysiwygEditorComponent, { autofocus: autofocus, editor: editor, className: b('editor') },
            react_1.default.createElement(extensions_1.ReactRendererComponent, { storage: editor.renderStorage }))));
});
exports.WysiwygEditorView.displayName = 'MarkdownWysiwgEditorView';
