"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mHiddenDataByPreset = exports.mToolbarConfigByPreset = exports.mHiddenData = exports.mTabsItemData = exports.mHruleItemData = exports.mToolbarConfig = exports.mFilePopupData = exports.mImagePopupData = exports.mYfmHtmlBlockButton = exports.mMermaidButton = exports.mMathListItem = exports.mMathListConfig = exports.mCodeListConfig = exports.mCodeblockItemData = exports.mTableButton = exports.mCutButton = exports.mQuoteButton = exports.mNoteButton = exports.mLinkButton = exports.mListMoveListConfig = exports.mCheckboxButton = exports.mListsListConfig = exports.mHeadingListConfig = exports.mBiusGroupConfig = exports.mMarkedItemData = exports.mMonospaceItemData = exports.mStrikethroughItemData = exports.mUnderlineItemData = exports.mItalicItemData = exports.mBoldItemData = exports.mHistoryGroupConfig = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const menubar_1 = require("../../i18n/menubar");
const commands_1 = require("../../markup/commands");
const shortcuts_1 = require("../../shortcuts");
const types_1 = require("../../toolbar/types");
const MToolbarColors_1 = require("../toolbar/markup/MToolbarColors");
const MToolbarFilePopup_1 = require("../toolbar/markup/MToolbarFilePopup");
const MToolbarImagePopup_1 = require("../toolbar/markup/MToolbarImagePopup");
const action_names_1 = require("./action-names");
const icons_1 = require("./icons");
const noop = () => { };
const isActiveFn = () => false;
const isEnableFn = () => true;
exports.mHistoryGroupConfig = [
    {
        id: action_names_1.ActionName.undo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'undo'),
        icon: icons_1.icons.undo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Undo),
        exec: (e) => (0, commands_1.undo)(e.cm),
        isActive: isActiveFn,
        isEnable: (e) => (0, commands_1.undoDepth)(e.cm.state) > 0,
    },
    {
        id: action_names_1.ActionName.redo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'redo'),
        icon: icons_1.icons.redo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Redo),
        exec: (e) => (0, commands_1.redo)(e.cm),
        isActive: isActiveFn,
        isEnable: (e) => (0, commands_1.redoDepth)(e.cm.state) > 0,
    },
];
/** Bold, Italic, Underline, Strike buttons group */
exports.mBoldItemData = {
    id: action_names_1.ActionName.bold,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'bold'),
    icon: icons_1.icons.bold,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Bold),
    exec: (e) => (0, commands_1.toggleBold)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mItalicItemData = {
    id: action_names_1.ActionName.italic,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'italic'),
    icon: icons_1.icons.italic,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Italic),
    exec: (e) => (0, commands_1.toggleItalic)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mUnderlineItemData = {
    id: action_names_1.ActionName.underline,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'underline'),
    icon: icons_1.icons.underline,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Underline),
    exec: (e) => (0, commands_1.toggleUnderline)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mStrikethroughItemData = {
    id: action_names_1.ActionName.strike,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'strike'),
    icon: icons_1.icons.strikethrough,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Strike),
    exec: (e) => (0, commands_1.toggleStrikethrough)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mMonospaceItemData = {
    id: action_names_1.ActionName.mono,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mono'),
    icon: icons_1.icons.mono,
    exec: (e) => (0, commands_1.toggleMonospace)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mMarkedItemData = {
    id: action_names_1.ActionName.mark,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mark'),
    icon: icons_1.icons.mark,
    exec: (e) => (0, commands_1.toggleMarked)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mBiusGroupConfig = [
    exports.mBoldItemData,
    exports.mItalicItemData,
    {
        id: action_names_1.ActionName.underline,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'underline'),
        icon: icons_1.icons.underline,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Underline),
        exec: (e) => (0, commands_1.toggleUnderline)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
    {
        id: action_names_1.ActionName.strike,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'strike'),
        icon: icons_1.icons.strikethrough,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Strike),
        exec: (e) => (0, commands_1.toggleStrikethrough)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
    {
        id: action_names_1.ActionName.mono,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'mono'),
        icon: icons_1.icons.mono,
        exec: (e) => (0, commands_1.toggleMonospace)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
    {
        id: action_names_1.ActionName.mark,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'mark'),
        icon: icons_1.icons.mark,
        exec: (e) => (0, commands_1.toggleMarked)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
];
exports.mHeadingListConfig = {
    icon: icons_1.icons.headline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'heading'),
    data: [
        {
            id: action_names_1.ActionName.heading1,
            title: menubar_1.i18n.bind(null, 'heading1'),
            icon: icons_1.icons.h1,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading1),
            exec: (e) => (0, commands_1.toH1)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading2,
            title: menubar_1.i18n.bind(null, 'heading2'),
            icon: icons_1.icons.h2,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading2),
            exec: (e) => (0, commands_1.toH2)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading3,
            title: menubar_1.i18n.bind(null, 'heading3'),
            icon: icons_1.icons.h3,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading3),
            exec: (e) => (0, commands_1.toH3)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading4,
            title: menubar_1.i18n.bind(null, 'heading4'),
            icon: icons_1.icons.h4,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading4),
            exec: (e) => (0, commands_1.toH4)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading5,
            title: menubar_1.i18n.bind(null, 'heading5'),
            icon: icons_1.icons.h5,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading5),
            exec: (e) => (0, commands_1.toH5)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading6,
            title: menubar_1.i18n.bind(null, 'heading6'),
            icon: icons_1.icons.h6,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading6),
            exec: (e) => (0, commands_1.toH6)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mListsListConfig = {
    icon: icons_1.icons.bulletList,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'list'),
    data: [
        {
            id: action_names_1.ActionName.bulletList,
            title: menubar_1.i18n.bind(null, 'ulist'),
            icon: icons_1.icons.bulletList,
            exec: (e) => (0, commands_1.toBulletList)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.orderedList,
            title: menubar_1.i18n.bind(null, 'olist'),
            icon: icons_1.icons.orderedList,
            exec: (e) => (0, commands_1.toOrderedList)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mCheckboxButton = {
    id: action_names_1.ActionName.checkbox,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'checkbox'),
    icon: icons_1.icons.checklist,
    exec: (e) => (0, commands_1.wrapToCheckbox)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mListMoveListConfig = {
    icon: icons_1.icons.lift,
    withArrow: true,
    title: 'Move list item',
    data: [
        {
            id: action_names_1.ActionName.sinkListItem,
            title: menubar_1.i18n.bind(null, 'list__action_sink'),
            icon: icons_1.icons.sink,
            exec: (e) => (0, commands_1.sinkListItem)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.liftListItem,
            title: menubar_1.i18n.bind(null, 'list__action_lift'),
            icon: icons_1.icons.lift,
            exec: (e) => (0, commands_1.liftListItem)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mLinkButton = {
    id: action_names_1.ActionName.link,
    type: types_1.ToolbarDataType.SingleButton,
    icon: icons_1.icons.link,
    title: (0, menubar_1.i18n)('link'),
    exec: (e) => (0, commands_1.insertLink)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mNoteButton = {
    id: action_names_1.ActionName.yfm_note,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'note'),
    icon: icons_1.icons.note,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Note),
    exec: (e) => (0, commands_1.wrapToYfmNote)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mQuoteButton = {
    id: action_names_1.ActionName.quote,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'quote'),
    icon: icons_1.icons.quote,
    exec: (e) => (0, commands_1.wrapToBlockquote)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mCutButton = {
    id: action_names_1.ActionName.yfm_cut,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'cut'),
    icon: icons_1.icons.cut,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Cut),
    exec: (e) => (0, commands_1.wrapToYfmCut)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mTableButton = {
    id: action_names_1.ActionName.table,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'table'),
    icon: icons_1.icons.table,
    exec: (e) => (0, commands_1.insertYfmTable)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mCodeblockItemData = {
    id: action_names_1.ActionName.code_block,
    title: menubar_1.i18n.bind(null, 'codeblock'),
    icon: icons_1.icons.codeBlock,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.CodeBlock),
    exec: (e) => (0, commands_1.wrapToCodeBlock)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mCodeListConfig = {
    icon: icons_1.icons.code,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'code'),
    data: [
        {
            id: action_names_1.ActionName.code_inline,
            title: menubar_1.i18n.bind(null, 'code_inline'),
            icon: icons_1.icons.code,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Code),
            exec: (e) => (0, commands_1.wrapToInlineCode)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        exports.mCodeblockItemData,
    ],
};
exports.mMathListConfig = {
    icon: icons_1.icons.functionInline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'math'),
    data: [
        {
            id: action_names_1.ActionName.math_inline,
            title: menubar_1.i18n.bind(null, 'math_inline'),
            icon: icons_1.icons.functionInline,
            exec: (e) => (0, commands_1.wrapToMathInline)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.math_block,
            title: menubar_1.i18n.bind(null, 'math_block'),
            icon: icons_1.icons.functionBlock,
            exec: (e) => (0, commands_1.wrapToMathBlock)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mMathListItem = Object.assign({ id: 'math', type: types_1.ToolbarDataType.ListButton }, exports.mMathListConfig);
exports.mMermaidButton = {
    id: action_names_1.ActionName.mermaid,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mermaid'),
    icon: icons_1.icons.mermaid,
    exec: (e) => (0, commands_1.insertMermaidDiagram)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mYfmHtmlBlockButton = {
    id: action_names_1.ActionName.yfm_html_block,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'html'),
    icon: icons_1.icons.html,
    exec: (e) => (0, commands_1.insertYfmHtmlBlock)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mImagePopupData = {
    id: 'image',
    type: types_1.ToolbarDataType.ButtonPopup,
    icon: icons_1.icons.image,
    title: (0, menubar_1.i18n)('image'),
    exec: noop,
    isActive: isActiveFn,
    isEnable: isEnableFn,
    renderPopup: (props) => react_1.default.createElement(MToolbarImagePopup_1.MToolbarImagePopup, Object.assign({}, props)),
};
exports.mFilePopupData = {
    id: 'file',
    type: types_1.ToolbarDataType.ButtonPopup,
    icon: icons_1.icons.file,
    title: (0, menubar_1.i18n)('file'),
    exec: noop,
    isActive: isActiveFn,
    isEnable: isEnableFn,
    renderPopup: (props) => react_1.default.createElement(MToolbarFilePopup_1.MToolbarFilePopup, Object.assign({}, props)),
};
/** prepared markup toolbar config */
exports.mToolbarConfig = [
    exports.mHistoryGroupConfig,
    exports.mBiusGroupConfig,
    [
        Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.mHeadingListConfig),
        Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.mListsListConfig),
        {
            id: 'colorify',
            type: types_1.ToolbarDataType.ReactComponent,
            component: MToolbarColors_1.MToolbarColors,
            width: 42,
        },
        exports.mLinkButton,
        exports.mNoteButton,
        exports.mCutButton,
        exports.mQuoteButton,
        Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.mCodeListConfig),
    ],
    [
        exports.mImagePopupData,
        {
            id: 'file',
            type: types_1.ToolbarDataType.ButtonPopup,
            icon: icons_1.icons.file,
            title: (0, menubar_1.i18n)('file'),
            exec: noop,
            isActive: isActiveFn,
            isEnable: isEnableFn,
            renderPopup: (props) => react_1.default.createElement(MToolbarFilePopup_1.MToolbarFilePopup, Object.assign({}, props)),
        },
        exports.mTableButton,
        exports.mCheckboxButton,
    ],
];
exports.mHruleItemData = {
    id: 'hrule',
    title: menubar_1.i18n.bind(null, 'hrule'),
    icon: icons_1.icons.horizontalRule,
    type: types_1.ToolbarDataType.SingleButton,
    exec: (e) => (0, commands_1.insertHRule)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mTabsItemData = {
    id: 'tabs',
    title: menubar_1.i18n.bind(null, 'tabs'),
    icon: icons_1.icons.tabs,
    type: types_1.ToolbarDataType.SingleButton,
    exec: (e) => (0, commands_1.insertYfmTabs)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mHiddenData = [exports.mHruleItemData, exports.mTabsItemData];
exports.mToolbarConfigByPreset = {
    zero: [exports.mHistoryGroupConfig],
    commonmark: [
        exports.mHistoryGroupConfig,
        [exports.mBoldItemData, exports.mItalicItemData],
        [
            Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.mHeadingListConfig),
            Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.mListsListConfig),
            exports.mLinkButton,
            exports.mQuoteButton,
            Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.mCodeListConfig),
        ],
    ],
    default: [
        exports.mHistoryGroupConfig,
        [exports.mBoldItemData, exports.mItalicItemData, exports.mStrikethroughItemData],
        [
            Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.mHeadingListConfig),
            Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.mListsListConfig),
            exports.mLinkButton,
            exports.mQuoteButton,
            Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.mCodeListConfig),
        ],
    ],
    yfm: [
        exports.mHistoryGroupConfig,
        [
            exports.mBoldItemData,
            exports.mItalicItemData,
            exports.mUnderlineItemData,
            exports.mStrikethroughItemData,
            exports.mMonospaceItemData,
        ],
        [
            Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.mHeadingListConfig),
            Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.mListsListConfig),
            exports.mLinkButton,
            exports.mNoteButton,
            exports.mCutButton,
            exports.mQuoteButton,
            Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.mCodeListConfig),
        ],
        [exports.mImagePopupData, exports.mFilePopupData, exports.mTableButton, exports.mCheckboxButton],
    ],
    full: exports.mToolbarConfig.slice(),
};
exports.mHiddenDataByPreset = {
    zero: [],
    commonmark: [
        ...exports.mHeadingListConfig.data,
        ...exports.mListsListConfig.data,
        exports.mLinkButton,
        exports.mQuoteButton,
        exports.mCodeblockItemData,
        exports.mHruleItemData,
    ],
    default: [
        ...exports.mHeadingListConfig.data,
        ...exports.mListsListConfig.data,
        exports.mLinkButton,
        exports.mQuoteButton,
        exports.mCodeblockItemData,
        exports.mHruleItemData,
    ],
    yfm: [
        ...exports.mHeadingListConfig.data,
        ...exports.mListsListConfig.data,
        exports.mLinkButton,
        exports.mQuoteButton,
        exports.mNoteButton,
        exports.mCutButton,
        exports.mCodeblockItemData,
        exports.mCheckboxButton,
        exports.mTableButton,
        exports.mImagePopupData,
        exports.mHruleItemData,
        exports.mFilePopupData,
        exports.mTabsItemData,
    ],
    full: [
        ...exports.mHeadingListConfig.data,
        ...exports.mListsListConfig.data,
        exports.mLinkButton,
        exports.mQuoteButton,
        exports.mNoteButton,
        exports.mCutButton,
        exports.mCodeblockItemData,
        exports.mCheckboxButton,
        exports.mTableButton,
        exports.mImagePopupData,
        exports.mHruleItemData,
        exports.mFilePopupData,
        exports.mTabsItemData,
    ],
};
