"use strict";
var _WysiwygContentHandler_view, _WysiwygContentHandler_parser;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WysiwygContentHandler = void 0;
const tslib_1 = require("tslib");
const prosemirror_model_1 = require("prosemirror-model");
const prosemirror_state_1 = require("prosemirror-state");
class WysiwygContentHandler {
    constructor(view, parser) {
        _WysiwygContentHandler_view.set(this, void 0);
        _WysiwygContentHandler_parser.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _WysiwygContentHandler_view, view, "f");
        tslib_1.__classPrivateFieldSet(this, _WysiwygContentHandler_parser, parser, "f");
    }
    clear() {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr
            .setSelection(new prosemirror_state_1.AllSelection(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.doc))
            .replaceSelection(prosemirror_model_1.Slice.empty));
    }
    replace(newMarkup) {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr
            .setSelection(new prosemirror_state_1.AllSelection(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.doc))
            .replaceSelection(new prosemirror_model_1.Slice(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(newMarkup).content, 0, 0)));
    }
    prepend(markup) {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr.insert(0, tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(markup).content));
    }
    append(markup) {
        var _a, _b;
        let tr = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr;
        if (((_a = tr.doc.lastChild) === null || _a === void 0 ? void 0 : _a.type.name) === 'paragraph' && tr.doc.lastChild.childCount === 0) {
            const pos = tr.doc.nodeSize - 3;
            tr = tr.replaceWith(pos - 1, pos + 1, tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(markup));
        }
        else {
            tr = this.appendContentTr(tr, markup);
        }
        if (((_b = tr.doc.lastChild) === null || _b === void 0 ? void 0 : _b.type.name) !== 'paragraph' || tr.doc.lastChild.childCount !== 0) {
            tr = this.appendContentTr(tr, '');
        }
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tr);
    }
    moveCursor(position) {
        switch (position) {
            case 'start': {
                const { tr } = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state;
                tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tr.setSelection(prosemirror_state_1.TextSelection.create(tr.doc, 1)));
                break;
            }
            case 'end': {
                const { lastChild } = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.doc;
                const { tr } = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state;
                const pos = tr.doc.nodeSize - 2;
                if (!(lastChild === null || lastChild === void 0 ? void 0 : lastChild.isTextblock) && !(lastChild === null || lastChild === void 0 ? void 0 : lastChild.isText)) {
                    this.appendContentTr(tr, '');
                }
                tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tr
                    .setSelection(prosemirror_state_1.TextSelection.create(tr.doc, tr.mapping.map(pos) - 1))
                    .scrollIntoView());
                break;
            }
            default:
                throw new Error('The "position" argument must be "start" or "end"');
        }
    }
    appendContentTr(tr, markup) {
        return tr.insert(tr.doc.nodeSize - 2, tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(markup).content);
    }
}
exports.WysiwygContentHandler = WysiwygContentHandler;
_WysiwygContentHandler_view = new WeakMap(), _WysiwygContentHandler_parser = new WeakMap();
