"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializerTokens = void 0;
const const_1 = require("./const");
exports.serializerTokens = {
    [const_1.ListNode.ListItem]: (state, node) => {
        state.renderContent(node);
    },
    [const_1.ListNode.BulletList]: (state, node) => {
        state.renderList(node, '  ', (_i, li) => (li.attrs[const_1.ListsAttr.Markup] || node.attrs[const_1.ListsAttr.Bullet] || '*') + ' ');
    },
    [const_1.ListNode.OrderedList]: (state, node) => {
        const start = node.attrs[const_1.ListsAttr.Order] || 1;
        const maxW = String(start + node.childCount - 1).length;
        const space = state.repeat(' ', maxW + 2);
        state.renderList(node, space, (i) => {
            const nStr = String(start + i);
            return state.repeat(' ', maxW - nStr.length) + nStr + '. ';
        });
    },
};
