"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableSpecs = exports.TableNode = void 0;
const const_1 = require("./const");
const parser_1 = require("./parser");
const schema_1 = require("./schema");
const serializer_1 = require("./serializer");
var const_2 = require("./const");
Object.defineProperty(exports, "TableNode", { enumerable: true, get: function () { return const_2.TableNode; } });
const TableSpecs = (builder) => {
    builder
        .addNode(const_1.TableNode.Table, () => ({
        spec: schema_1.schemaSpecs[const_1.TableNode.Table],
        toMd: serializer_1.serializerTokens[const_1.TableNode.Table],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.TableNode.Table] },
    }))
        .addNode(const_1.TableNode.Head, () => ({
        spec: schema_1.schemaSpecs[const_1.TableNode.Head],
        toMd: serializer_1.serializerTokens[const_1.TableNode.Head],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.TableNode.Head] },
    }))
        .addNode(const_1.TableNode.Body, () => ({
        spec: schema_1.schemaSpecs[const_1.TableNode.Body],
        toMd: serializer_1.serializerTokens[const_1.TableNode.Body],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.TableNode.Body] },
    }))
        .addNode(const_1.TableNode.Row, () => ({
        spec: schema_1.schemaSpecs[const_1.TableNode.Row],
        toMd: serializer_1.serializerTokens[const_1.TableNode.Row],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.TableNode.Row] },
    }))
        .addNode(const_1.TableNode.HeaderCell, () => ({
        spec: schema_1.schemaSpecs[const_1.TableNode.HeaderCell],
        toMd: serializer_1.serializerTokens[const_1.TableNode.HeaderCell],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.TableNode.HeaderCell] },
    }))
        .addNode(const_1.TableNode.DataCell, () => ({
        spec: schema_1.schemaSpecs[const_1.TableNode.DataCell],
        toMd: serializer_1.serializerTokens[const_1.TableNode.DataCell],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.TableNode.DataCell] },
    }));
};
exports.TableSpecs = TableSpecs;
