"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnderlineSpecs = exports.underlineType = exports.underlineMarkName = void 0;
const tslib_1 = require("tslib");
const markdown_it_ins_1 = tslib_1.__importDefault(require("markdown-it-ins"));
const schema_1 = require("../../../../utils/schema");
exports.underlineMarkName = 'ins';
exports.underlineType = (0, schema_1.markTypeFactory)(exports.underlineMarkName);
const UnderlineSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(markdown_it_ins_1.default))
        .addMark(exports.underlineMarkName, () => ({
        spec: {
            parseDOM: [{ tag: 'ins' }, { tag: 'u' }],
            toDOM() {
                return ['ins'];
            },
        },
        toMd: { open: '++', close: '++', mixable: true, expelEnclosingWhitespace: true },
        fromMd: { tokenSpec: { name: exports.underlineMarkName, type: 'mark' } },
    }));
};
exports.UnderlineSpecs = UnderlineSpecs;
