"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.render = exports.EmojiSuggestComponent = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const classname_1 = require("../../../../classname");
const suggest_1 = require("../../../../i18n/suggest");
const ErrorBoundary_1 = require("../../../../react-utils/ErrorBoundary");
const b = (0, classname_1.cn)('emoji-suggest');
const placement = ['bottom-start', 'top-start', 'bottom-end', 'top-end'];
const ITEM_HEIGHT = 28; // px
const VISIBLE_ITEMS_COUNT = 10;
const MAX_LIST_HEIGHT = ITEM_HEIGHT * VISIBLE_ITEMS_COUNT; // px
function calcListHeight(itemsCount) {
    if (itemsCount <= 0)
        return undefined;
    return Math.min(MAX_LIST_HEIGHT, itemsCount * ITEM_HEIGHT);
}
const EmojiSuggestComponent = ({ anchor, currentIndex, items, onClick, onEnterKeyDown, onEscapeKeyDown, onOutsideClick, }) => {
    if (!anchor)
        return null;
    return (react_1.default.createElement(uikit_1.Popup, { open: true, anchorRef: { current: anchor }, placement: placement, onEnterKeyDown: onEnterKeyDown, onEscapeKeyDown: onEscapeKeyDown, onOutsideClick: onOutsideClick },
        react_1.default.createElement("div", { className: b() },
            react_1.default.createElement(uikit_1.List, { virtualized: true, items: items, sortable: false, filterable: false, emptyPlaceholder: (0, suggest_1.i18n)('empty-msg'), itemHeight: ITEM_HEIGHT, itemsHeight: calcListHeight(items.length), renderItem: renderItem, deactivateOnLeave: false, activeItemIndex: currentIndex, onItemClick: (_item, index) => onClick(index), className: b('list'), itemClassName: b('list-item') }))));
};
exports.EmojiSuggestComponent = EmojiSuggestComponent;
function renderItem({ origName, symbol, origShortcuts }) {
    return (react_1.default.createElement("div", { key: origName, className: b('item') },
        react_1.default.createElement("div", { className: b('item-info') },
            react_1.default.createElement("div", { className: b('item-icon') }, symbol),
            react_1.default.createElement("div", { className: b('item-name') },
                ":",
                origName,
                ":")),
        origShortcuts !== undefined && (react_1.default.createElement("div", { className: b('item-shortcuts') }, origShortcuts.slice(0, 4).map((val) => (react_1.default.createElement("span", { key: `${origName}_${val}`, className: b('item-shortcut') }, val)))))));
}
function render(props) {
    return (react_1.default.createElement(ErrorBoundary_1.ErrorLoggerBoundary, null,
        react_1.default.createElement(exports.EmojiSuggestComponent, Object.assign({}, props))));
}
exports.render = render;
