import type { Action, ExtensionAuto } from '../../../core';
import type { FileUploadHandler } from '../../../utils';
import { ImgSizeSpecsOptions } from './ImgSizeSpecs';
import { AddImageAttrs } from './actions';
import { addImageAction } from './const';
export declare type ImgSizeOptions = ImgSizeSpecsOptions & {
    imageUploadHandler?: FileUploadHandler;
    /**
     * If we need to set dimensions for uploaded images
     *
     * @default false
     */
    needToSetDimensionsForUploadedImages?: boolean;
};
export declare const ImgSize: ExtensionAuto<ImgSizeOptions>;
declare global {
    namespace WysiwygEditor {
        interface Actions {
            [addImageAction]: Action<AddImageAttrs>;
        }
    }
}
