"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerKeyset = exports.i18n = void 0;
const i18n_1 = require("@gravity-ui/i18n");
const configure_1 = require("../configure");
const i18n = new i18n_1.I18N();
exports.i18n = i18n;
// en – default lang for editor
i18n.setLang((0, configure_1.getConfig)().lang || configure_1.Lang.En);
(0, configure_1.subscribeConfigure)((config) => {
    if (config.lang) {
        i18n.setLang(config.lang);
    }
});
function registerKeyset(keyset, data) {
    i18n.registerKeyset(configure_1.Lang.En, keyset, data.en);
    i18n.registerKeyset(configure_1.Lang.Ru, keyset, data.ru);
    return i18n.keyset(keyset);
}
exports.registerKeyset = registerKeyset;
