"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const react_utils_1 = require("../../react-utils");
const TooltipButton = ({ domRef, onOutsideClick, children }) => {
    var _a;
    const [width, setWidth] = (0, react_1.useState)(0);
    const [open, , hide, toggleOpen] = (0, react_utils_1.useBooleanState)(false);
    const placement = ['bottom-end', 'bottom-start'];
    const ref = (0, react_1.useRef)(null);
    const childrenRef = (0, react_1.useRef)(children);
    (0, react_1.useLayoutEffect)(() => {
        var _a, _b;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.clientWidth) {
            setWidth((_b = ref.current) === null || _b === void 0 ? void 0 : _b.clientWidth);
        }
    }, [(_a = ref.current) === null || _a === void 0 ? void 0 : _a.clientWidth]);
    return (react_1.default.createElement(uikit_1.Popup, { open: true, keepMounted: false, hasArrow: false, anchorRef: { current: domRef }, placement: 'right-start', offset: [3, -(width + 3)], onOutsideClick: onOutsideClick, modifiers: [
            {
                name: 'preventOverflow',
                enabled: false,
            },
        ] },
        react_1.default.createElement(uikit_1.Button, { onClick: toggleOpen, ref: ref, size: "s", view: open ? 'normal' : 'raised' },
            react_1.default.createElement(uikit_1.Icon, { data: icons_1.Ellipsis })),
        react_1.default.createElement(uikit_1.Popup, { open: open, anchorRef: ref, onClose: hide, placement: placement }, childrenRef.current)));
};
exports.TooltipButton = TooltipButton;
