"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipButtonPluginView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const BaseTooltip_1 = require("../BaseTooltip");
const TooltipButton_1 = require("./TooltipButton");
class TooltipButtonPluginView extends BaseTooltip_1.BaseTooltipPluginView {
    constructor(view, options) {
        super(view, options);
        this.forceEdit = false;
        this.toggleEdit = () => {
            this.forceEdit = !this.forceEdit;
            this.render();
        };
        this.onViewFocus = () => {
            this.forceEdit = false;
            this.manualHidden = false;
            this.render();
        };
        this.enableHideOnBlur = options.disableHideOnBlur !== true;
        this.buttonContent = options.buttonContent;
        this.formContent = options.formContent;
        if (this.enableHideOnBlur) {
            this.view.dom.addEventListener('focus', this.onViewFocus);
        }
    }
    destroy() {
        super.destroy();
        this.view.dom.removeEventListener('focus', this.onViewFocus);
    }
    renderContent(currentNode) {
        return (react_1.default.createElement(react_1.default.Fragment, null, this.forceEdit && this.formContent ? (react_1.default.createElement("div", null, this.formContent(this.view, currentNode, this.changeAttrsCb))) : (react_1.default.createElement(TooltipButton_1.TooltipButton, { domRef: currentNode.dom, onOutsideClick: this.onOutsideClick }, this.buttonContent(this.view, currentNode, this.toggleEdit)))));
    }
    setCurrentNode(node) {
        var _a, _b;
        super.setCurrentNode(node);
        (_b = (_a = this.currentNode) === null || _a === void 0 ? void 0 : _a.dom) === null || _b === void 0 ? void 0 : _b.addEventListener('dblclick', this.toggleEdit);
    }
    updateTooltipView() {
        var _a, _b;
        (_b = (_a = this.currentNode) === null || _a === void 0 ? void 0 : _a.dom) === null || _b === void 0 ? void 0 : _b.removeEventListener('dblclick', this.toggleEdit);
        super.updateTooltipView();
    }
}
exports.TooltipButtonPluginView = TooltipButtonPluginView;
