"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonMarkPreset = void 0;
const markdown_1 = require("../extensions/markdown");
const lodash_1 = require("../lodash");
const zero_1 = require("./zero");
const CommonMarkPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    builder.use(zero_1.ZeroPreset, opts);
    builder
        .use(markdown_1.Html)
        .use(markdown_1.HorizontalRule)
        .use(markdown_1.Code, (_a = opts.code) !== null && _a !== void 0 ? _a : {})
        .use(markdown_1.Bold, (_b = opts.bold) !== null && _b !== void 0 ? _b : {})
        .use(markdown_1.Link, (_c = opts.link) !== null && _c !== void 0 ? _c : {})
        .use(markdown_1.Lists, (_d = opts.lists) !== null && _d !== void 0 ? _d : {})
        .use(markdown_1.Italic, (_e = opts.italic) !== null && _e !== void 0 ? _e : {})
        .use(markdown_1.Breaks, (_f = opts.breaks) !== null && _f !== void 0 ? _f : {})
        .use(markdown_1.CodeBlock, (_g = opts.codeBlock) !== null && _g !== void 0 ? _g : {})
        .use(markdown_1.Blockquote, (_h = opts.blockquote) !== null && _h !== void 0 ? _h : {});
    if (opts.image !== false) {
        builder.use((0, lodash_1.isFunction)(opts.image) ? opts.image : markdown_1.Image);
    }
    if (opts.heading !== false) {
        if ((0, lodash_1.isFunction)(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(markdown_1.Heading, (_j = opts.heading) !== null && _j !== void 0 ? _j : {});
    }
};
exports.CommonMarkPreset = CommonMarkPreset;
