"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSameNodeType = exports.markTypeFactory = exports.nodeTypeFactory = void 0;
const prosemirror_model_1 = require("prosemirror-model");
const nodeTypeFactory = (nodeName) => (schema) => schema.nodes[nodeName];
exports.nodeTypeFactory = nodeTypeFactory;
const markTypeFactory = (markName) => (schema) => schema.marks[markName];
exports.markTypeFactory = markTypeFactory;
function isSameNodeType(a, b) {
    const aType = a instanceof prosemirror_model_1.Node ? a.type : a;
    const bType = b instanceof prosemirror_model_1.Node ? b.type : b;
    return aType === bType;
}
exports.isSameNodeType = isSameNodeType;
