"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withLatex = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_2 = require("@diplodoc/latex-extension/react");
const useLatexRuntime_1 = require("./useLatexRuntime");
function withLatex(opts) {
    return (Component) => (0, react_1.forwardRef)(function WithLatex(props, ref) {
        const { meta, html } = props;
        const renderLatex = (0, react_2.useLatex)();
        (0, useLatexRuntime_1.useLatexRuntime)(meta, opts.runtime);
        (0, react_1.useEffect)(() => {
            renderLatex({ throwOnError: false });
        }, [html, renderLatex]);
        return react_1.default.createElement(Component, Object.assign({}, props, { ref: ref }));
    });
}
exports.withLatex = withLatex;
