"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withYfmHtmlBlock = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_2 = require("@diplodoc/html-extension/react");
const useYfmHtmlBlockRuntime_1 = require("./useYfmHtmlBlockRuntime");
function withYfmHtmlBlock(opts) {
    return (Component) => (0, react_1.forwardRef)(function WithYfmHtml(props, ref) {
        const { meta, html, yfmHtmlBlockConfig } = props;
        (0, useYfmHtmlBlockRuntime_1.useYfmHtmlBlockRuntime)(meta, opts.runtime);
        const yfmHtmlBlock = (0, react_2.useDiplodocEmbeddedContentController)();
        (0, react_1.useEffect)(() => {
            if (yfmHtmlBlock) {
                if (yfmHtmlBlockConfig) {
                    yfmHtmlBlock.setConfig(yfmHtmlBlockConfig);
                }
                yfmHtmlBlock.initialize();
            }
        }, [yfmHtmlBlock, html, yfmHtmlBlockConfig]);
        return react_1.default.createElement(Component, Object.assign({}, props, { ref: ref }));
    });
}
exports.withYfmHtmlBlock = withYfmHtmlBlock;
