/// <reference types="react" />
import { Extension } from '../core';
import { Editor, EditorOptions, EditorPreset } from './Editor';
import { ExtensionsOptions } from './wysiwyg-preset';
export declare type UseMarkdownEditorProps<T extends object = {}> = Omit<EditorOptions, 'extensions' | 'renderStorage' | 'preset'> & {
    /**
     * A set of plug-in extensions.
     *
     * @default 'full'
     */
    preset?: EditorPreset;
    breaks?: boolean;
    /** Used only first value. Сhanging the value will not lead to anything */
    extensionOptions?: Omit<ExtensionsOptions, 'reactRenderer'> & T;
    /** Used only first value. Сhanging the value will not lead to anything */
    extraExtensions?: Extension;
};
export declare function useMarkdownEditor<T extends object = {}>(props: UseMarkdownEditorProps<T>, deps?: React.DependencyList): Editor;
