import { newlineInCode, setBlockType } from 'prosemirror-commands';
import { toParagraph } from '../../base/BaseSchema';
import { codeBlockType } from './const';
export { newlineInCode };
export const resetCodeblock = (state, dispatch, view) => {
    const { selection } = state;
    if (selection.empty &&
        selection.$from.parent.type === codeBlockType(state.schema) &&
        (view === null || view === void 0 ? void 0 : view.endOfTextblock('backward', state))) {
        return toParagraph(state, dispatch, view);
    }
    return false;
};
export const setCodeBlockType = ({ serializer }) => (state, dispatch) => {
    const nodeType = codeBlockType(state.schema);
    if (!setBlockType(nodeType)(state))
        return false;
    if (dispatch) {
        const markup = serializer.serialize(state.selection.content().content);
        dispatch(state.tr.replaceSelectionWith(nodeType.createAndFill({}, markup ? state.schema.text(markup) : null)));
    }
    return true;
};
