import { ListNode, ListsAttr } from './const';
export const serializerTokens = {
    [ListNode.ListItem]: (state, node) => {
        state.renderContent(node);
    },
    [ListNode.BulletList]: (state, node) => {
        state.renderList(node, '  ', (_i, li) => (li.attrs[ListsAttr.Markup] || node.attrs[ListsAttr.Bullet] || '*') + ' ');
    },
    [ListNode.OrderedList]: (state, node) => {
        const start = node.attrs[ListsAttr.Order] || 1;
        const maxW = String(start + node.childCount - 1).length;
        const space = state.repeat(' ', maxW + 2);
        state.renderList(node, space, (i) => {
            const nStr = String(start + i);
            return state.repeat(' ', maxW - nStr.length) + nStr + '. ';
        });
    },
};
