import { toggleMark } from 'prosemirror-commands';
import { createToggleMarkAction } from '../../../utils/actions';
import { markInputRule } from '../../../utils/inputrules';
import { withLogAction } from '../../../utils/keymap';
import { UnderlineSpecs, underlineMarkName, underlineType } from './UnderlineSpecs';
export { underlineMarkName, underlineType } from './UnderlineSpecs';
/** @deprecated Use `underlineMarkName` instead */
export const underline = underlineMarkName;
const undAction = 'underline';
export const Underline = (builder, opts) => {
    builder.use(UnderlineSpecs);
    builder
        .addAction(undAction, ({ schema }) => createToggleMarkAction(underlineType(schema)))
        .addInputRules(({ schema }) => ({
        rules: [
            markInputRule({ open: '++', close: '++', ignoreBetween: '+' }, underlineType(schema)),
        ],
    }));
    if (opts === null || opts === void 0 ? void 0 : opts.underlineKey) {
        const { underlineKey } = opts;
        builder.addKeymap(({ schema }) => ({
            [underlineKey]: withLogAction('underline', toggleMark(underlineType(schema))),
        }));
    }
};
