import React from 'react';
import { CircleXmarkFill } from '@gravity-ui/icons';
import { Button } from '@gravity-ui/uikit';
import { cn } from '../../../../classname';
import { i18n } from '../../../../i18n/gpt/errors';
import { IconRefuge } from '../IconRefuge/IconRefuge';
import './ErrorScreen.css';
export const cnGptDialogErrorScreen = cn('gpt-dialog-error-screen');
export const ErrorScreen = ({ onRetry, onStartAgain }) => {
    return (React.createElement("div", { className: cnGptDialogErrorScreen() },
        React.createElement("div", { className: cnGptDialogErrorScreen('content') },
            React.createElement(IconRefuge, { containerClassName: cnGptDialogErrorScreen('icon'), data: CircleXmarkFill, refugeSize: 28, size: 16 }),
            React.createElement("span", { className: cnGptDialogErrorScreen('text') }, i18n('error-text'))),
        React.createElement("div", { className: cnGptDialogErrorScreen('buttons') },
            React.createElement(Button, { view: "normal", onClick: onStartAgain }, i18n('start-again-button')),
            React.createElement(Button, { view: "normal", onClick: onRetry }, i18n('retry-button')))));
};
