import React from 'react';
import { ArrowsRotateRight } from '@gravity-ui/icons';
import { Icon, Label, Portal, Spin, Tooltip } from '@gravity-ui/uikit';
import { icons } from '../../../bundle/config/icons';
import { cn } from '../../../classname';
import './widget.css';
export function renderWidget(container, props) {
    return (React.createElement(Portal, { container: container },
        React.createElement(UploadLabel, Object.assign({}, props))));
}
const cnLabel = cn('upload-label');
export function UploadLabel({ fileName, fileType, status, errorText, onReUploadClick, }) {
    const icon = fileType === 'image' ? icons.image : icons.file;
    if (status === 'uploading') {
        return (React.createElement(Label, { size: "xs", theme: "info", icon: React.createElement(Icon, Object.assign({}, icon)), className: cnLabel({ status }) },
            React.createElement("div", { className: cnLabel('content') },
                React.createElement("span", { title: fileName, className: cnLabel('filename') }, fileName),
                React.createElement(Spin, { size: "xs" }))));
    }
    if (status === 'success') {
        return (React.createElement(Label, { size: "xs", theme: "success", icon: React.createElement(Icon, Object.assign({}, icon)), className: cnLabel({ status }) },
            React.createElement("div", { className: cnLabel('content') },
                React.createElement("span", { title: fileName, className: cnLabel('filename') }, fileName))));
    }
    if (status === 'error') {
        return (React.createElement(Tooltip, { content: errorText },
            React.createElement(Label, { size: "xs", interactive: true, theme: "danger", icon: React.createElement(Icon, Object.assign({}, icon)), onClick: onReUploadClick, className: cnLabel({ status }) },
                React.createElement("div", { className: cnLabel('content') },
                    React.createElement("span", { className: cnLabel('filename') }, fileName),
                    React.createElement(Icon, { data: ArrowsRotateRight, size: 16 })))));
    }
    return null;
}
