import React, { useLayoutEffect, useRef, useState } from 'react';
import { Ellipsis } from '@gravity-ui/icons';
import { Button, Icon, Popup } from '@gravity-ui/uikit';
import { useBooleanState } from '../../react-utils';
export const TooltipButton = ({ domRef, onOutsideClick, children }) => {
    var _a;
    const [width, setWidth] = useState(0);
    const [open, , hide, toggleOpen] = useBooleanState(false);
    const placement = ['bottom-end', 'bottom-start'];
    const ref = useRef(null);
    const childrenRef = useRef(children);
    useLayoutEffect(() => {
        var _a, _b;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.clientWidth) {
            setWidth((_b = ref.current) === null || _b === void 0 ? void 0 : _b.clientWidth);
        }
    }, [(_a = ref.current) === null || _a === void 0 ? void 0 : _a.clientWidth]);
    return (React.createElement(Popup, { open: true, keepMounted: false, hasArrow: false, anchorRef: { current: domRef }, placement: 'right-start', offset: [3, -(width + 3)], onOutsideClick: onOutsideClick, modifiers: [
            {
                name: 'preventOverflow',
                enabled: false,
            },
        ] },
        React.createElement(Button, { onClick: toggleOpen, ref: ref, size: "s", view: open ? 'normal' : 'raised' },
            React.createElement(Icon, { data: Ellipsis })),
        React.createElement(Popup, { open: open, anchorRef: ref, onClose: hide, placement: placement }, childrenRef.current)));
};
