import React from 'react';
import { BaseTooltipPluginView } from '../BaseTooltip';
import { TooltipButton } from './TooltipSelect';
export class TooltipSelectPluginView extends BaseTooltipPluginView {
    constructor(view, options) {
        var _a;
        super(view, options);
        this.onOutsideClick = () => {
            if (this.enableHideOnBlur && !this.view.hasFocus()) {
                this.manualHidden = true;
                this.render();
            }
        };
        this.onViewFocus = () => {
            this.manualHidden = false;
            this.render();
        };
        this.buttonText = options.buttonText;
        this.items = options.items;
        this.buildAttrs = options.buildAttrs;
        this.withSearch = (_a = options.withSearch) !== null && _a !== void 0 ? _a : true;
        this.enableHideOnBlur = options.disableHideOnBlur !== true;
        if (this.enableHideOnBlur) {
            this.view.dom.addEventListener('focus', this.onViewFocus);
        }
    }
    destroy() {
        super.destroy();
        this.view.dom.removeEventListener('focus', this.onViewFocus);
    }
    renderContent(currentNode) {
        var _a;
        return (React.createElement(TooltipButton, { domRef: currentNode.dom, buttonTitle: (_a = this.buttonText) === null || _a === void 0 ? void 0 : _a.call(this, currentNode.node), items: this.items, onUpdate: (v) => this.changeAttrsCb(this.buildAttrs(v), { setFocus: true }), withSearch: this.withSearch, onOutsideClick: this.onOutsideClick }));
    }
}
