import React, { RefObject } from 'react';
export declare type ResizeDirection = 'left' | 'right';
export interface UseNodeResizingArgs {
    width?: number;
    height?: number;
    onResize?: ({ width, height }: {
        width?: number;
        height?: number;
    }) => void;
    ref: RefObject<HTMLImageElement | HTMLDivElement> | null;
    delay?: number;
    threshold?: number;
    minWidth?: number;
}
export declare const useNodeResizing: ({ width, height, onResize, ref, delay, threshold, minWidth, }: UseNodeResizingArgs) => {
    startResizing: (event: React.MouseEvent<HTMLElement>, direction: ResizeDirection) => void;
    state: {
        resizing: boolean;
        width: number | undefined;
        height: number | undefined;
    };
};
