import { Key } from '../shortcuts';
export function enterKeyHandler(handler) {
    return (event) => {
        if (event.key === Key.Enter) {
            handler(event);
        }
    };
}
export function escapeKeyHandler(handler) {
    return (event) => {
        if (event.key === Key.Esc) {
            handler(event);
        }
    };
}
export function combinedKeyHandler(handlers) {
    return (event) => {
        const handler = handlers[event.key];
        if (handler) {
            handler(event);
        }
    };
}
